

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

    do_click
    UpdateModule
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0
    variable DebugFlag 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
    variable allchannels 0

    variable ModuleName v1724
    variable ModuleMenu {}
    variable ModuleAddress {}
    variable ModuleIndex 1

    variable DPPEnable 1

#    for the Register Menus each item is a list
#      0) name for menu
#      1) register
#      2) file containing support implementation
#      3) Display procedure  (null if none)
#      4) parameter update procedure   (null if none)
#      5) parameter save procedure (null if none)
#      6) parameter restore procedure (null if none)

    variable ModuleRegMenu { \
       {"Configuration"                       Config        Config.tml        GetConfig DrawConfig null null} \
       {"Buffer Organisation"                 BufferOrg     BuffOrg.tml       GetBuffOrg DrawBuffOrg null null} \
       {"Acquisition Window"                  CustomSize    CustSize.tml      GetCustSize DrawCustSize null null} \
       {"Start/Stop Run Delay"                RunDelay      RunDelay.tml      GetRunDelay DrawRunDelay null null} \
       {"Channel Enable Mask"                 Enable        ChEnable.tml      GetChEnable DrawChEnable null null} \
       {"Trigger Source Enable Mask"          TrigSrcEnable TrigSrcEnable.tml GetTrigSrcEnable DrawTrigSrcEnable null null} \
       {"Front Panel Trigger Out Enable Mask" FPTrigOutEnable  FPTrigEnable.tml  GetFPTrigEnable DrawFPTrigEnable null null} \
       {"Analog Monitor"                      AnalogMon     AnalogMon.tml     GetAnalogMon DrawAnalogMon null null} \
       {"Front Panel I/O Control"             FPIOControl   FPIOCtrl.tml      GetFPIO DrawFPIO null null} \
       {"Acquisition Control"                 AcqControl    AcqCtrl.tml       GetAcqCtrl DrawAcqCtrl null null} \
       {"Acquisition Status"                  AcqStatus     AcqStatus.tml     GetAcqStatus DrawAcqStatus null null} \
       {"VME Control"                         VMECtrl       VMECtrl.tml       GetVMECtrl DrawVMECtrl null null} \
       {"VME Status"                          VMEStatus     VMEStatus.tml     GetVMEStatus DrawVMEStatus null null} \
       {"System Options"                      SystemOpts    SystemOpts.tml    GetSystemOpts DrawSystemOpts null null} \
    }

    variable ChRegMenu { \
       {"Channel Status"              Status   ChStatus.tml  GetChStatus DrawChStatus null null} \
       {"DPP Parameter #1"            DPP_PAR1 DPP_PAR1.tml  GetDPP_PAR1 DrawDPP_PAR1 SaveDPP_PAR1 RestDPP_PAR1} \
       {"DPP Parameter #2"            DPP_PAR2 DPP_PAR2.tml  GetDPP_PAR2 DrawDPP_PAR2 SaveDPP_PAR2 RestDPP_PAR2} \
       {"DPP Parameter #3"            DPP_PAR3 DPP_PAR3.tml  GetDPP_PAR3 DrawDPP_PAR3 SaveDPP_PAR3 RestDPP_PAR3} \
       {"DPP Parameter #4"            DPP_PAR4 DPP_PAR4.tml  GetDPP_PAR4 DrawDPP_PAR4 SaveDPP_PAR4 RestDPP_PAR4} \
       {"Channel Buffer Occupancy"    Bufs     Bufs.tml      GetBufs DrawBufs null null} \
       {"Channel DAC"                 DAC      DAC.tml       GetDAC DrawDAC SaveDAC RestDAC} \
       {"Channel Pre Trigger Window"  PreTrig  PreTrig.tml   GetPreTrig DrawPreTrig SavePreTrig RestPreTrig} \
       {"Channel Events Per Buffer"   EvtsPerBuf  EvtsPerBuf.tml GetEvtsPerBuf DrawEvtsPerBuf SaveEvtsPerBuf RestEvtsPerBuf} \
    }

#   registers for Save/Restore not handled by above (module registers)
#     NOTE 24/02/11   Add AnalogMon back in when firmware fixed 
    variable SaveRestoreMenu {Enable Config BufferOrg TrigSrcEnable FPTrigOutEnable FPIOControl \
                 AcqControl CustomSize }


    variable ModuleRegItem [lindex $ModuleRegMenu 0]
    variable ModuleReg [lindex $ModuleRegItem 0]

    variable ChRegItem [lindex $ChRegMenu 0]
    variable ChReg [lindex $ChRegItem 0]


#    source all implementation files to load implementation code
  foreach item $ModuleRegMenu  {
     source [file join V1724 [lindex $item 2]]
     set updateproc [lindex $item 3]
     if {$updateproc != "null"} {eval $updateproc}
  }

  foreach item $ChRegMenu  {
     source [file join V1724 [lindex $item 2]]
     set updateproc [lindex $item 3]
     if {$updateproc != "null"} {eval $updateproc}
  }



   proc do_RegisterHelp {W} {
      variable [set W]RegItem

       set f [lindex [set [set W]RegItem] 2]

        set Txtfile [file join V1724 [file rootname $f].txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc do_ExpertHelp {} {

        set Txtfile [file join V1724 Expert.txt]
        set z [catch {open $Txtfile r} file]
        if {$z != 0} {
            Alert "Unable to access $Txtfile\nInformation coming very soon!!\nFor now read the manual!!"
            return
        }

        set text [read $file]
        close $file

        Alert "$text"
  }

   proc show_variables {} {
        variable allchannels

        variable allmodules
        variable LogFlag
        variable DebugFlag
        variable ShowLogFlag
        variable ModuleRegItem
        variable ChRegItem
        variable DPPEnable
        variable Rmsg
        variable Wmsg
        variable OutputClockEnable
        variable ClockDelayEnable
        variable ClockDelay

             InsertLog "DPPEnable=$DPPEnable"
             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag; DebugFlag=$DebugFlag "
             InsertLog "allchannels=$allchannels; allmodules=$allmodules"
             InsertLog "ModuleReg=$ModuleRegItem"
             InsertLog "ChannelReg=$ChRegItem"
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
           InsertLog "HasBeenConfigured = [::VMEConfig::ReadRegister HasBeenConfigured]"
           InsertLog "HasBeenRestored = [::VMEConfig::ReadRegister HasBeenRestored]"

       InsertLog ">>>   [ReadNetVar DACQ.Sstate]"

   }

   proc WriteRegister {RegName RegData} {
       global errorCode errorInfo
       variable ModuleName
       variable ModuleIndex
       variable allmodules
       variable Wmsg

       set AcqState [ReadNetVar DACQ.Sstate]   ;# get data acqusition program state (may not exist)

       global errorCode
       if {$errorCode == 0x10004} {set AcqState 0; EmptyLog}  ;# suppresses error popup

      if {$AcqState == 2} {      ;#  acquisition running 
         WriteNetVar DACQ.Sstate 258      ;#   pause
         after 500                        ;# allow acquisition to cause modules to go BUSY
         if {[lindex [split $RegName _] 0] == "DPP"}  {WriteVMERegister AcqControl 0}
      }

      if {$allmodules == 0} then {set r $ModuleName#$ModuleIndex} else {set r $ModuleName#*}

#           InsertLog "WriteRegisters $r.$RegName $RegData [format 0x%x $RegData]"

       set z [catch {::namespace inscope ::urn:VMEAccessServer WriteRegisters $r.$RegName $RegData} Wmsg]

       if {$z == 0} {
#           InsertLog "WriteRegister $r.$RegName $RegData [format 0x%x $RegData] returned: [lindex $Wmsg 5]"
#           InsertLog "WriteRegister $r.$RegName $RegData [format 0x%x $RegData]"
       } else {
           InsertLog "WriteRegister $r.$RegName failed: Code= $errorCode; Info= [first [split $errorInfo \n]]"
       }

      if {$AcqState == 2} {
         if {[lindex [split $RegName _] 0] == "DPP"}  {WriteVMERegister AcqControl 4}
         WriteNetVar DACQ.Sstate 2    ;# restore original state
      }

   }

   proc do_Select {i} {    ;# select module
        variable ModuleIndex

         set ModuleIndex $i
         UpdateModule
   }

   proc UpdateModule {} {

       do_UpdateModuleRegisters
       do_UpdateChannelRegisters
   }

   proc UpdateChannel {} {

       do_UpdateChannelRegisters
   }

   proc do_UpdateModuleRegisters {} {
        variable ModuleRegMenu

        foreach item $ModuleRegMenu  {
            set updateproc [lindex $item 3]
            if {$updateproc != "null"} {eval $updateproc}
        }
   }

   proc do_UpdateChannelRegisters {} {
       variable ChRegMenu
       foreach item $ChRegMenu  {
           set updateproc [lindex $item 3]
           if {$updateproc != "null"} {eval $updateproc}
       }
   }

   proc do_SelectModuleRegister {w} {
        variable ModuleReg
        variable ModuleRegItem
        variable ModuleRegMenu

      foreach item $ModuleRegMenu  {
         set name [lindex $item 0]
         if {"$w" == "$name"} {
             set ModuleRegItem $item
             set ModuleReg [lindex $item 1]
         }
      }
   }

   proc do_SelectChannelRegister {w} {
        variable ChReg
        variable ChRegItem
        variable ChRegMenu

      foreach item $ChRegMenu  {
         set name [lindex $item 0]
         if {"$w" == "$name"} {
             set ChRegItem $item
             set ChReg [lindex $item 1]
         }
      }
   }

    proc do_SetModuleRegister {w v} {
        variable DebugFlag
        variable $w

        if {$DebugFlag == 1} {InsertLog "do_SetModuleRegister: $w = $v"}

        switch -glob $w {
            Config.*        {set $w $v; SetConfig}
            BuffOrg         {set $w $v; SetBuffOrg}
            ChEnableMask*   {set $w $v; SetChEnable}
            FPTrigEnable*   {set $w $v; SetFPTrigEnable}
            TrigSrcEnable*  {set $w $v; SetTrigSrcEnable}
            AnalogMon*      {set $w $v; SetAnalogMon}
            FPIO*           {set $w $v; SetFPIO}
            CustSize        {set $w $v; SetCustSize}
            PostTrig        {set $w $v; SetPostTrig}
            RunDelay        {set $w $v; SetRunDelay}

            ReConfig        {WriteRegister ConfigReload 0; after 1000}
            Reset           {WriteRegister Reset 0; after 1000}

            AcqControl  -
            Clear -
            FlushEvBlk -
            SoftwareSyncReset -
            EvtsPerBuf -
            BLTEventNum -
            BufferOrg -
            SoftTrig        {WriteRegister $w $v}

            AcqCtrl*        {set $w $v; SetAcqCtrl}
            AcqStatus*      {}
            VMECtrl*        {set $w $v; SetVMECtrl}
            VMEStatus*      {}

            default {set $w $v}
        }
   }

    proc do_SetChannelRegister {w i vl} {
        variable allchannels
        variable DebugFlag

        if {$DebugFlag == 1} {InsertLog "do_SetChannelRegister:  $w $i = $vl"}

        set Ch $i
        if {$allchannels == 0} {set ch $Ch} else {set ch "\[0-7\]"}

        switch -glob $w {
            EVTSPERBUF {variable $w.Ch$i; set $w.Ch$i $vl; WriteRegister EvtsPerBuf.Ch$ch $vl}
            DAC        {variable $w.Ch$i; set $w.Ch$i $vl; WriteRegister DAC.Ch$ch $vl}
            PRETRIG    {variable $w.Ch$i; set $w.Ch$i $vl; WriteRegister PreTrig.Ch$ch [expr $vl/2]}
            default {}
        }
   }

   proc do_SetDPPparameter {w s vl} {
        variable allchannels
        variable DebugFlag

        if {$DebugFlag == 1} {InsertLog "SetDPPparameter $w $s $vl"}

       set Ch [expr $s & 7]
       set id [expr $s >> 3]

       if {$allchannels == 0} {set ch $Ch} else {set ch "\[0-7\]"}

       switch $w {
           DPP_PAR1 {
               switch $id {
                  0  {set Var DPP_PAR1.RiseTime$Ch;        set Reg DPP_PAR1.Ch$ch.RiseTime}
                  1  {set Var DPP_PAR1.AveragingWindow$Ch; set Reg DPP_PAR1.Ch$ch.AvWindow}
                  2  {set Var DPP_PAR1.DecayTime$Ch;       set Reg DPP_PAR1.Ch$ch.DecayTime}
                  3  {set Var DPP_PAR1.Delta$Ch;           set Reg DPP_PAR1.Ch$ch.Delta}
               }
           }
           DPP_PAR2 {
               switch $id {
                  0  {set Var DPP_PAR2.TrapezoidRiseTime$Ch; set Reg DPP_PAR2.Ch$ch.TrapRiseTime}
                  1  {set Var DPP_PAR2.TrapezoidFlatTop$Ch;  set Reg DPP_PAR2.Ch$ch.TrapFlatTop}
                  2  {set Var DPP_PAR2.PeakValue2Divider$Ch; set Reg DPP_PAR2.Ch$ch.PeakValueShift}
                  3  {set Var DPP_PAR2.BaseLineMean$Ch;      set Reg DPP_PAR2.Ch$ch.BaseLineMean}
               }
           }
           DPP_PAR3 {
               switch $id {
                  0  {set Var DPP_PAR3.Threshold$Ch;    set Reg DPP_PAR3.Ch$ch.Threshold}
                  1  {set Var DPP_PAR3.FlatTopDelay$Ch; set Reg DPP_PAR3.Ch$ch.FlatTopDelay}
                  2  {set Var DPP_PAR3.Decimation$Ch;    set Reg DPP_PAR3.Ch$ch.Decimation}
                  3  {set Var DPP_PAR3.PeakAvWindow$Ch;    set Reg DPP_PAR3.Ch$ch.PeakAvWin}
                  4  {set Var DPP_PAR3.DigitalGain$Ch;    set Reg DPP_PAR3.Ch$ch.DigitalGain}
               }
           }
           DPP_PAR4 {
               switch $id {
                  0  {set Var DPP_PAR4.TrigWinWidth$Ch;  set Reg DPP_PAR4.Ch$ch.TrigWinWidth}
                  1  {set Var DPP_PAR4.TrigHoldOff$Ch; set Reg DPP_PAR4.Ch$ch.TrigHoldOff}
                  2  {set Var DPP_PAR4.PeakHoldOff$Ch; set Reg DPP_PAR4.Ch$ch.PeakHoldOff}
                  3  {set Var DPP_PAR4.OvLapTrapRej$Ch; set Reg DPP_PAR4.Ch$ch.OvLapTrapRej}
                  4  {set Var DPP_PAR4.InvertInput$Ch; set Reg DPP_PAR4.Ch$ch.InvertInput}
               } 
           }
       }

       variable $Var
       set $Var $vl

       if {$DebugFlag == 1} {InsertLog "SetDPPparameter: WriteRegister $Reg $vl"}

       WriteRegister $Reg $vl

   }
 
    proc do_Save {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleRegMenu
        variable ChRegMenu
        variable SaveRestoreMenu

        set SAV $ModuleIndex

           set ModuleIndex $which
           InsertLog "Saving Settings for CAEN [set ModuleName]#[set ModuleIndex]"

           foreach item $ModuleRegMenu  {
               set saveproc [lindex $item 5]
               if {$saveproc != "null"} {eval $saveproc}
           }

           foreach item $ChRegMenu  {
               set saveproc [lindex $item 5]
               if {$saveproc != "null"} {eval $saveproc}
           }

           foreach item $SaveRestoreMenu {

               DBSetValue $item  [ReadRegister $item]
           }
 

        set ModuleIndex $SAV
    }

    proc do_SaveAll {} {
        variable ModuleName
        variable ModuleMenu

        foreach module $ModuleMenu {do_Save $module}

        InsertLog "Settings for All CAEN [set ModuleName] modules updated in DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules updated in DB"
    }

    proc do_Restore {which} {
        variable ModuleIndex
        variable ModuleName
        variable ModuleMenu
        variable ModuleRegMenu
        variable ChRegMenu
        variable SaveRestoreMenu
        variable allmodules
        variable allchannels

        set SAV1 $ModuleIndex
        set SAV2 $allmodules
        set SAV3 $allchannels

        set allmodules 0
        set allchannels 0
        set ModuleIndex $which

        InsertLog "Restoring Settings for CAEN [set ModuleName]#[set ModuleIndex]"

#        WriteRegister Reset 0   ;# software reset modules

           foreach item $ModuleRegMenu  {
               set restproc [lindex $item 6]
               if {$restproc != "null"} {eval $restproc}
           }

           foreach item $ChRegMenu  {
               set restproc [lindex $item 6]
               if {$restproc != "null"} {eval $restproc}
           }

           foreach item $SaveRestoreMenu {

               WriteRegister $item [DBGetValue $item]
           }

        set ModuleIndex $SAV1

        set allmodules $SAV2
        set allchannels $SAV3

    }

    proc do_RestoreAll {} {
        variable ModuleName
        variable ModuleMenu

       foreach module $ModuleMenu {do_Restore $module}

        ::VMEConfig::WriteRegister HasBeenRestored 1

        InsertLog "Settings for All CAEN [set ModuleName] modules restored from DB"

        Elog INFORMATION "Settings for All CAEN [set ModuleName] modules restored from DB"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable DebugFlag
       variable ShowLogFlag
       variable ModuleIndex

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {UpdateModule}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}
                   DEBUGON    {set DebugFlag 1}
                   DEBUGOFF   {set DebugFlag 0}

                   ALLCHANS   {variable allchannels; set allchannels [expr ($allchannels + 1) & 1]}
                   ALLMODULES {variable allmodules; set allmodules [expr ($allmodules + 1) & 1]}

                   MODULE   {do_Select [lindex $w 1]}

                   MREGISTER      {do_SelectModuleRegister [string range $w 10 end]}
                   MREGISTERHELP  {do_RegisterHelp Module}

                   EXPERT {
                      switch [lindex $w 1] {
                        Help      {do_ExpertHelp}
                        Reset -
                        Clear -
                        SoftTrig -
                        SoftwareSyncReset -
                        FlushEvBlk -
                        ReConfig  {do_SetModuleRegister [lindex $w 1] 0}
                        AcqStart  {source [file join V1724 AcqStart.tcl]}
                        AcqHalt   {source [file join V1724 AcqHalt.tcl]}
                        RdOutPause   {WriteNetVar DACQ.Sstate 258}
                        RdOutResume  {WriteNetVar DACQ.Sstate 2}
                        default   {}
                      }
                   }
                   EXPERTHELP    {do_ExpertHelp}

                   CHREGISTER      {do_SelectChannelRegister [string range $w 11 end]}
                   CHREGISTERHELP  {do_RegisterHelp Ch}

                   MSETTING      {do_SetModuleRegister [lindex $w 1] [lindex $w 2]}
                   MSETTINGS     {do_SetModuleRegister [lindex $cgidata 4] [lindex $cgidata 5]}
 
                   EVTSPERBUF -
                   DAC -
                   PRETRIG {
                       do_SetChannelRegister [lindex $w 0] [lindex $w 1] [lindex $w 2]
                   }

                   CHSETTING  {
                       do_SetChannelRegister [lindex $w 1] [lindex $w 2] [lindex $w 3]
                   }

                   DPP_PAR1 -
                   DPP_PAR2 -
                   DPP_PAR3 -
                   DPP_PAR4 {
                       do_SetDPPparameter [lindex $w 0] [lindex $w 1] [lindex $w 2]
                   }

                   DPPSETTING {
                       do_SetDPPparameter [lindex $w 1] [lindex $w 2] [lindex $w 3]
                   }

                   PLLWRITEFLASH {PLLWriteFlash}
                   PLLREADFLASH  {PLLReadFlash}
                   PLLUPDATEFLASH {PLLUpdateFlash}
                   PLLRELOADFLASH {PLLReloadFlash}

                   PLLCLKENABLE {
                       switch [lindex $w 1] {
                           false {variable ClockDelayEnable; set ClockDelayEnable 0}
                           true  {variable ClockDelayEnable; set ClockDelayEnable 1}
                       }
                       PLLUpdateFlash
                   }

                   PLLOUTENABLE {
                       switch [lindex $w 1] {
                           false {variable OutputClockEnable; set OutputClockEnable 0}
                           true  {variable OutputClockEnable; set OutputClockEnable 1}
                       }
                       PLLUpdateFlash
                   }

                   PLLCLKDELAY   {variable ClockDelay; set ClockDelay [lindex $w 1]; PLLUpdateFlash}
                   
                   SAVEALL      {do_SaveAll}
                   RESTALL      {do_RestoreAll}
                   SAVE         {do_Save $ModuleIndex}
                   RESTORE      {do_Restore $ModuleIndex}

                   REDISPLAY  {} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

}   ;# end of if {$started == 0}


     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

